<form method="post" name="compose" enctype="multipart/form-data" action="<?= Horde::url('compose.php?uniq=' . uniqid(rand())) ?>">

<?php
$count = 0;
if (!isset($error) || !is_array($error)) {
    $numerrors = 0;
} else {
    $numerrors = count($error);
}
$errorsleft = $numerrors;
if ($numerrors > 0) {
    for ($k = 0; $k < count($error); $k++) {
        if (isset($ignoreall)) {
            $ignores = explode(',', $ignoreall);
            if (member($error[$k][0],$ignores)) $errorsleft--;
        }
    }
}
$i = 0;
?>
<table width="100%" border="0" cellspacing="0" cellpadding="1">
  <tr class="header">
    <td colspan="8" class="header">
      <b>
<?php if ($errorsleft > 0): ?>
        <?= _("Spell Checker") ?> - <i><?= $errorsleft ?> <?php if ($errorsleft > 1) echo _("spelling errors"); else echo _("spelling error"); ?></i>
<?php else: ?>
        <?= _("Spell check complete") ?> - <?= _("No spelling errors") ?>
<?php endif; ?>
      </b>
    </td>
  </tr>
<?php
while ($count < $prefs->getValue('num_words') && $i < $numerrors) {
    if (!isset($error) || !is_array($error)) {
        echo _("Spell check complete");
        break;
    }
    if (isset($ignoreall)) {
        $ignores = explode(',', $ignoreall);
        if (member($error[$i][0],$ignores))
            $includeword = 0;
        else
            $includeword = 1;
	}
    else
        $includeword = 1;
    if ($includeword) {
?>

  <tr class="item">
    <td class="item"><?= _("Correct") ?></td>
    <td colspan="3" nowrap="nowrap">
<?php
    $offset = $error[$i][1];
    $word = $error[$i][0];
    $alt = $error[$i][2];
    echo '<font color="ff0000">"' . htmlspecialchars($word) . '"</font>';
    echo _(" in ");
    $context = highlight_error(htmlspecialchars($word), htmlspecialchars($f_message), htmlspecialchars($offset));
    if ($context != '')
        echo "<span class=\"fixed\">$context</span>";
    else
        echo _("none");
?>

    </td>
    <td><b><i><?= _("Change"); ?></i></b></td>
    <td><b><i><?= _("Change All"); ?></i></b></td>
    <td><?= _("Ignore") ?></td>
    <td><?= _("Ignore All") ?></td>
  </tr>
  <tr>
    <td class="item"><b><?= _("Suggestions") ?></b></td>
    <td class="item">
      <input type="hidden" name="oldword[<?= $count ?>]" value="<?= htmlspecialchars($word) ?>" />
      <input type="hidden" name="wordoffset[<?= $count ?>]" value="<?= htmlspecialchars($offset) ?>" />
      <select name="subs[<?= $count ?>]" onchange="change_selected(<?= $count ?>);">
<?php
if ($alt != '') {
    $checkedval = 3;
    $altwords = explode(', ', $alt);
    for ($j = 0; $j < count($altwords); $j++) {
        echo '<option value="' . htmlspecialchars($altwords[$j]) . '">' . htmlspecialchars($altwords[$j]) . '</option>';
    }
} else {
    $checkedval = 3;
    echo '<option value="0">' . _("No suggestions") . '</option>';
}
?></select>
    </td>
    <td class="item"><b><?php
        if (!empty($alt)) {
            echo _("or");
        } else {
            echo _("Replace with:");
        }
?></b></td>
    <td class="item"><input type="text" name="subtext[<?= $count ?>]" size="12" onchange="change_selected(<?= $count ?>);" /></td>
    <td class="item"><input type="radio" value="1" name="opt[<?= $count ?>]" <?php if ($checkedval == 1) echo 'checked="checked"'; ?> /></td>
    <td class="item"><input type="radio" value="2" name="opt[<?= $count ?>]" <?php if ($checkedval == 2) echo 'checked="checked"'; ?> /></td>
    <td class="item"><input type="radio" value="3" name="opt[<?= $count ?>]" <?php if ($checkedval == 3) echo 'checked="checked"'; ?> /></td>
    <td class="item"><input type="radio" value="4" name="opt[<?= $count ?>]" <?php if ($checkedval == 4) echo 'checked="checked"'; ?> /></td>
  </tr>
<?php
        $count++;
    }
    $i++;
}
?>
  <tr class="item">
    <td colspan="8" class="item">
      <input type="button" class="button" onclick="document.compose.actionID.value='<?= SPELL_CHECK_CANCEL ?>'; document.compose.submit();" value="<?= _("Cancel") ?>" /><i>&nbsp;<?= _("(Discard all changes and return to the compose screen.)") ?></i>
    </td>
  </tr>
<?php if ($actionID == SPELL_CHECK_FORWARD || $errorsleft == 0): ?>
  <tr class="item">
    <td colspan="8" class="item">
      <input type="button" class="button" onclick="document.compose.actionID.value='<?= SPELL_CHECK_DONE ?>'; document.compose.submit();" value="<?= _("Done") ?>" /><i>&nbsp;<?= _("(Return to the compose screen after applying all changes made thus far.  Changes on the current screen will NOT be applied.)") ?></i>
    </td>
  </tr>
<?php endif; ?>
<?php if ($errorsleft > 0): ?>
  <tr class="item">
    <td colspan="8" class="item">
      <input type="button" class="button" onclick="document.compose.actionID.value='<?= SPELL_CHECK_FORWARD ?>'; document.compose.submit();" value="<?= _("Next") ?>" /><i>&nbsp;<?= _("(Apply these changes and move to next screen.)") ?></i>
    </td>
  </tr>
<?php endif; ?>
  <tr><td colspan="8">&nbsp;</td></tr>
  <tr class="header"><td colspan="8" class="header"><b><?= _("Corrected Text") ?></b></td></tr>
  <tr><td colspan="8" class="item">
    <div class="fixed"><pre><?= htmlspecialchars($f_newmsg . $f_message) ?></pre></div>
  </td></tr>
</table>

<!-- Maintain lots of state -->
<input type="hidden" name="actionID" value="" />
<input type="hidden" name="spellcheck" value="" />
<input type="hidden" name="popup" value="<?= htmlspecialchars(Horde::getFormData('popup', '')); ?>" />
<input type="hidden" name="index" value="<?php if (isset($index)) echo htmlspecialchars($index); ?>" />
<?php if (isset($is_reply)): ?><input type="hidden" name="is_reply" value="1" /><?php endif; ?>
<?php if (isset($in_reply_to)): ?><input type="hidden" name="in_reply_to" value="<?= htmlspecialchars($in_reply_to) ?>" /><?php endif; ?>
<?php if (isset($references)): ?><input type="hidden" name="references" value="<?= htmlspecialchars($references) ?>" /><?php endif; ?>
<input type="hidden" name="oldmsg" value="<?= htmlspecialchars($f_oldmsg) ?>" />
<input type="hidden" name="message" value="<?= htmlspecialchars($f_message) ?>" />
<input type="hidden" name="newmsg" value="<?= htmlspecialchars($f_newmsg) ?>" />
<input type="hidden" name="ignoreall" value="<?= htmlspecialchars($f_ignoreall) ?>" />
<input type="hidden" name="changeall" value="<?= htmlspecialchars(Horde::getFormData('changeall')) ?>" />
<input type="hidden" name="identity" value="<?= htmlspecialchars(Horde::getFormData('identity')) ?>" />
<input type="hidden" name="from" value="<?= htmlspecialchars(Horde::getFormData('from')) ?>" />
<input type="hidden" name="subject" value="<?php if (isset($subject)) echo htmlspecialchars($subject) ?>" />
<input type="hidden" name="reloaded" value="1" />
<?php if (Horde::getFormData('save_sent_mail') == 'on'): ?>
<input type="hidden" name="save_sent_mail" value="on" />
<input type="hidden" name="sent_mail_folder" value="<?= htmlspecialchars(Horde::getFormData('sent_mail_folder')) ?>" />
<?php endif; ?>
<?php if (Horde::getFormData('request_return_receipt') == 'on'): ?>
<input type="hidden" name="request_return_receipt" value="on" />
<?php endif; ?>

<!-- To: addresses -->
<?php if (!empty($f_to)): ?><input type="hidden" name="to" value="<?= htmlspecialchars(Horde::getFormData('to')) ?>" /><?php endif; ?>
<?php if (!empty($f_to_new)): ?><input type="hidden" name="to_new" value="<?= htmlspecialchars(Horde::getFormData('to_new')) ?>" /><?php endif; ?>
<?php if (!empty($f_to_list) && is_array($f_to_list)): ?>
<?php foreach ($f_to_list as $search => $found): ?>
<input type="hidden" name="to_list[<?= htmlspecialchars($search) ?>]" value="<?= htmlspecialchars($found) ?>" />
<?php if (isset($f_to_field) && isset($f_to_field[$search])): ?>
<input type="hidden" name="to_field[<?= htmlspecialchars($search) ?>]" value="<?= htmlspecialchars($f_to_field[$search]) ?>" />
<?php endif; ?>
<?php endforeach; ?>
<?php endif; ?>

<!-- Cc: addresses -->
<?php if (!empty($f_cc)): ?><input type="hidden" name="cc" value="<?= htmlspecialchars(Horde::getFormData('cc')) ?>" /><?php endif; ?>
<?php if (!empty($f_cc_new)): ?><input type="hidden" name="cc_new" value="<?= htmlspecialchars(Horde::getFormData('cc_new')) ?>" /><?php endif; ?>
<?php if (!empty($f_cc_list) && is_array($f_cc_list)): ?>
<?php foreach ($f_cc_list as $search => $found): ?>
<input type="hidden" name="cc_list[<?= htmlspecialchars($search) ?>]" value="<?= htmlspecialchars($found) ?>" />
<?php if (isset($f_cc_field) && isset($f_cc_field[$search])): ?>
<input type="hidden" name="cc_field[<?= htmlspecialchars($search) ?>]" value="<?= htmlspecialchars($f_cc_field[$search]) ?>" />
<?php endif; ?>
<?php endforeach; ?>
<?php endif; ?>

<!-- Bcc: addresses -->
<?php if (!empty($f_bcc)): ?><input type="hidden" name="bcc" value="<?= htmlspecialchars(Horde::getFormData('bcc')) ?>" /><?php endif; ?>
<?php if (!empty($f_bcc_new)): ?><input type="hidden" name="bcc_new" value="<?= htmlspecialchars(Horde::getFormData('bcc_new')) ?>" /><?php endif; ?>
<?php if (!empty($f_bcc_list) && is_array($f_bcc_list)): ?>
<?php foreach ($f_bcc_list as $search => $found): ?>
<input type="hidden" name="bcc_list[<?= htmlspecialchars($search) ?>]" value="<?= htmlspecialchars($found) ?>" />
<?php if (isset($f_bcc_field) && isset($f_bcc_field[$search])): ?>
<input type="hidden" name="bcc_field[<?= htmlspecialchars($search) ?>]" value="<?= htmlspecialchars($f_bcc_field[$search]) ?>" />
<?php endif; ?>
<?php endforeach; ?>
<?php endif; ?>

<!-- Attachment Form -->
<?php if (isset($HTTP_POST_VARS['attachments_name']) && is_array($HTTP_POST_VARS['attachments_name']) && count($HTTP_POST_VARS['attachments_name']) > 0): ?>
<?php for ($i = 0; $i < count($HTTP_POST_VARS['attachments_name']); $i++): ?>
<input type="hidden" name="attachments_name[]" value="<?= htmlspecialchars($HTTP_POST_VARS['attachments_name'][$i]) ?>" />
<input type="hidden" name="attachments_size[]" value="<?= htmlspecialchars($HTTP_POST_VARS['attachments_size'][$i]) ?>" />
<input type="hidden" name="attachments_file[]" value="<?= htmlspecialchars($HTTP_POST_VARS['attachments_file'][$i]) ?>" />
<input type="hidden" name="attachments_type[]" value="<?= htmlspecialchars($HTTP_POST_VARS['attachments_type'][$i]) ?>" />
<?php endfor; ?>
<?php endif; ?>

</form>
